import { isURL } from '@/utils/validate'
import { ACCESS_TOKEN } from "@/store/mutation-types"
import {notification} from 'ant-design-vue'
//import Vue from "vue/types/vue";
import Vue from 'vue'

export const serialize = data => {
  let list = [];
  Object.keys(data).forEach(ele => {
      list.push(`${ele}=${data[ele]}`)
  })
  return list.join('&');
};

export function timeFix() {
  const time = new Date()
  const hour = time.getHours()
  return hour < 9 ? '早上好' : (hour <= 11 ? '上午好' : (hour <= 13 ? '中午好' : (hour < 20 ? '下午好' : '晚上好')))
}

export function welcome() {
  const arr = ['休息一会儿吧', '准备吃什么呢?', '要不要打一把 DOTA', '我猜你可能累了']
  let index = Math.floor((Math.random()*arr.length))
  return arr[index]
}

/**
 * 触发 window.resize
 */
export function triggerWindowResizeEvent() {
  let event = document.createEvent('HTMLEvents')
  event.initEvent('resize', true, true)
  event.eventType = 'message'
  window.dispatchEvent(event)
}

/**
 * 过滤对象中为空的属性
 * @param obj
 * @returns {*}
 */
export function filterObj(obj) {
  if (!(typeof obj == 'object')) {
    return;
  }

  for ( var key in obj) {
    if (obj.hasOwnProperty(key)
      && (obj[key] == null || obj[key] == undefined || obj[key] === '')) {
      delete obj[key];
    }
  }
  return obj;
}

/**
 * 时间格式化
 * @param value
 * @param fmt
 * @returns {*}
 */
export function formatDate(value, fmt) {
  var regPos = /^\d+(\.\d+)?$/;
  if(regPos.test(value)){
    //如果是数字
    let getDate = new Date(value);
    let o = {
      'M+': getDate.getMonth() + 1,
      'd+': getDate.getDate(),
      'h+': getDate.getHours(),
      'm+': getDate.getMinutes(),
      's+': getDate.getSeconds(),
      'q+': Math.floor((getDate.getMonth() + 3) / 3),
      'S': getDate.getMilliseconds()
    };
    if (/(y+)/.test(fmt)) {
      fmt = fmt.replace(RegExp.$1, (getDate.getFullYear() + '').substr(4 - RegExp.$1.length))
    }
    for (let k in o) {
      if (new RegExp('(' + k + ')').test(fmt)) {
        fmt = fmt.replace(RegExp.$1, (RegExp.$1.length === 1) ? (o[k]) : (('00' + o[k]).substr(('' + o[k]).length)))
      }
    }
    return fmt;
  }else{
    //TODO
    value = value.trim();
    return value.substr(0,fmt.length);
  }
}

// 生成首页路由
export function generateIndexRouter(data) {
let indexRouter = [{
          path: '/',
          name: 'dashboard',
          //component: () => import('@/components/layouts/BasicLayout'),
          component: resolve => require(['@/components/layouts/TabLayout'], resolve),
          meta: { title: '首页' },
          redirect: '/dashboard/analysis',
          children: [
            ...generateChildRouters(data),
            {
              "path": "/dashboard",
              "name": "dashboards",
              "redirect": "/dashboard/analysis",
              component: resolve => require(['@/components/layouts/PageView.vue'], resolve),
              "meta": {
                "title": "项目介绍",
                "icon": "setting"
              },
              children:[
                {path:"/dashboard/analysis",
                  fullPath:"/dashboard/analysis",
                  component: resolve => require(['@/views/dashboard/analysis.vue'], resolve),
                  name:"Analysis",
                  meta:{
                    icon:"",
                    title:"项目介绍",
                    breadcrumb:false
                  }}
              ]
              }

          ]
        },{
          "path": "*", "redirect": "/404", "hidden": true
        }
]

  return indexRouter;
}

// 生成嵌套路由（子路由）
function  generateChildRouters (data) {
  try {
  const routers = new Array();
  for (var item of data) {
    let component = "";

    if(item.component.indexOf("layouts")>=0){
      if(item.url.indexOf("#")!=-1){
        let urlList = item.url.split("#");
        item.url = urlList[0];
        item.redirect = urlList[1];
      }else{
        if(item.children){
          if(item.children[0]){
            item.redirect = item.children[0].url;
          }else if(item.children[1]){
            item.redirect = item.children[1].url;
          }
        }
      }
       component = "components"+item.component;
    }else{
       component = "views"+item.component;
    }

    // eslint-disable-next-line
    let URL = (item.url|| '').replace(/{{([^}}]+)?}}/g, (s1, s2) => eval(s2)) // URL支持{{ window.xxx }}占位符变量
    if (isURL(URL)) {
      item.url = URL;
    }

    let menu =  {
      path: item.url,
      name: item.componentName,
      redirect:item.redirect,
      component: resolve => require(['@/' + component+'.vue'], resolve),
      hidden:item.hidden,
      //component:()=> import(`@/views/${item.component}.vue`),
      meta: {
        title:item.name ,
        icon: item.icon,
        num:item.num0,//给标题消息提示
        //url:item.meta.url ,
        //permissionList:item.meta.permissionList,
        //keepAlive:item.meta.keepAlive
      }
    }
    if(item.alwaysShow){
      menu.alwaysShow = true;
      menu.redirect = menu.path;
    }
    if (item.children && item.children.length > 0) {
      menu.children = [...generateChildRouters( item.children)];
    }
    //--update-begin----author:scott---date:20190320------for:根据后台菜单配置，判断是否路由菜单字段，动态选择是否生成路由（为了支持参数URL菜单）------
    //判断是否生成路由
    if(item.route && item.route === '0'){
      //console.log(' 不生成路由 item.route：  '+item.route);
      //console.log(' 不生成路由 item.path：  '+item.path);
    }else{
      routers.push(menu);
    }
    //--update-end----author:scott---date:20190320------for:根据后台菜单配置，判断是否路由菜单字段，动态选择是否生成路由（为了支持参数URL菜单）------
  }
  return routers
  }catch (e) {
    notification.error({ message: '系统提示', description: '路由数据出错！请到菜单管理进行修改！',duration: 4})
    return []
  }
}

/**
 * 深度克隆对象、数组
 * @param obj 被克隆的对象
 * @return 克隆后的对象
 */
export function cloneObject(obj) {
  return JSON.parse(JSON.stringify(obj))
}

/**
 * 随机生成数字
 *
 * 示例：生成长度为 12 的随机数：randomNumber(12)
 * 示例：生成 3~23 之间的随机数：randomNumber(3, 23)
 *
 * @param1 最小值 | 长度
 * @param2 最大值
 * @return int 生成后的数字
 */
export function randomNumber() {
  // 生成 最小值 到 最大值 区间的随机数
  const random = (min, max) => {
    return Math.floor(Math.random() * (max - min + 1) + min)
  }
  if (arguments.length === 1) {
    let [length] = arguments
  // 生成指定长度的随机数字，首位一定不是 0
    let nums = [...Array(length).keys()].map((i) => (i > 0 ? random(0, 9) : random(1, 9)))
    return parseInt(nums.join(''))
  } else if (arguments.length >= 2) {
    let [min, max] = arguments
    return random(min, max)
  } else {
    return Number.NaN
  }
}

/**
 * 随机生成字符串
 * @param length 字符串的长度
 * @param chats 可选字符串区间（只会生成传入的字符串中的字符）
 * @return string 生成的字符串
 */
export function randomString(length, chats) {
  if (!length) length = 1
  if (!chats) chats = '0123456789qwertyuioplkjhgfdsazxcvbnm'
  let str = ''
  for (let i = 0; i < length; i++) {
    let num = randomNumber(0, chats.length - 1)
    str += chats[num]
  }
  return str
}

/**
 * 随机生成uuid
 * @return string 生成的uuid
 */
export function randomUUID() {
  let chats = '0123456789abcdef'
  return randomString(32, chats)
}

/**
 * 下划线转驼峰
 * @param string
 * @returns {*}
 */
export function underLine2CamelCase(string){
  return string.replace( /_([a-z])/g, function( all, letter ) {
    return letter.toUpperCase();
  });
}

/**
 * 判断是否显示办理按钮
 * @param bpmStatus
 * @returns {*}
 */
export function showDealBtn(bpmStatus){
  if(bpmStatus!="1"&&bpmStatus!="3"&&bpmStatus!="4"){
    return true;
  }
  return false;
}

/**
 * 数组去重
 * @param {*} arr 数组
 */
export function unique (arr) {
  return Array.from(new Set(arr))
}

/**
 * 导出
 * @param pross     执行下载的方法
 * @param name      导出的文件名（默认是data.xlsx）
 * @param callback  pross执行完毕会的回调函数
 */
export function exportFile(pross, name = "data.xlsx", callback) {
  pross.then(res =>{
    let blob = res;
    /*let reader = new FileReader();
    reader.readAsDataURL(blob);    // 转换为base64，可以直接放入a表情href
    reader.onload = function (e) {
      // 转换完成，创建一个a标签用于下载
      var a = document.createElement('a');
      a.download = name;
      a.href = e.target.result;
      document.querySelector("body").appendChild(a)    // 修复firefox中无法触发click
      a.click();
      document.querySelector("body").removeChild(a);
    }*/
    var ele = document.createElement('a');// 创建下载链接
    ele.download = name;//设置下载的名称
    ele.style.display = 'none';// 隐藏的可下载链接
    // 字符内容转变成blob地址
    //var blob = new Blob([content]);
    ele.href = URL.createObjectURL(res);
    // 绑定点击时间
    document.body.appendChild(ele);
    ele.click();
    // 然后移除
    document.body.removeChild(ele);
    if(callback) {
      callback();
      console.log("callback")
    }
  });

/*  var xhr = new XMLHttpRequest();
  xhr.open('post', url, true);        // 也可以使用POST方式，根据接口
  //设置SessionId
  xhr.setRequestHeader("Authorization", Vue.ls.get(ACCESS_TOKEN));
  xhr.responseType = "blob";    // 返回类型blob
  // 定义请求完成的处理函数，请求前也可以增加加载框/禁用下载按钮逻辑
  xhr.onload = function () {
    // 请求完成
    if (this.status === 200) {
      // 返回200
      var blob = this.response;
      var reader = new FileReader();
      reader.readAsDataURL(blob);    // 转换为base64，可以直接放入a表情href
      reader.onload = function (e) {
        // 转换完成，创建一个a标签用于下载
        var a = document.createElement('a');
        a.download = 'userData.xlsx';
        a.href = e.target.result;
        document.querySelector("body").appendChild(a)    // 修复firefox中无法触发click
        a.click();
        document.querySelector("body").remove(a);
      }
    }
  };
  // 发送ajax请求
  xhr.send()*/
}


